#include <stdio.h>
#include <mpi.h>

 main(int argc, char* argv[])
 {
    int my_rank;       /* rank of process      */
    int p;             /* number of processes  */
    int local_n;        /*num. trapezoids for each processor*/
    int source;        /* rank of sender       */
    int dest=0;          /* rank of receiver     */
    int tag = 0;       /* tag for messages     */
    MPI_Status  status;        /* return status for    */
                               /* receive              */
   double deltax, pi = 3.141592654, integral, fleftx, frightx, 
          leftx, rightx, f(double x), total;
   int nintervals = 128, i;

    /* Start up MPI */
    MPI_Init(&argc, &argv);

    /* Find out process rank  */
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    /* Find out number of processes */
    MPI_Comm_size(MPI_COMM_WORLD, &p);

   deltax = (0.5*pi)/(double)nintervals;
   local_n = nintervals/p;
   integral = 0.0;
   leftx = deltax * (double) my_rank * local_n;
   rightx = leftx + local_n * deltax;
   fleftx = f(leftx);
   frightx = f(rightx);
   integral += deltax * 0.5 *(fleftx + frightx);

   if (my_rank != 0) 
   {
     MPI_Ssend(&integral,1,MPI_DOUBLE,dest,tag,MPI_COMM_WORLD);
   }
   else /* my_rank == 0*/
   {
     total = integral;
     for(source =1; source < p; source++)
     {
       MPI_Recv(&integral,1,MPI_DOUBLE,source,tag,MPI_COMM_WORLD,&status);
	   total = total + integral;
     }
     printf ("\n Integral = %f\n", total);
   }
   MPI_Finalize();
 }
 
 double f(double x)
  {
   double y;
   
   y = cos(x);
   return (1.0/sqrt(1.0 - 0.5*y*y));
}
